#include "memcheck.h"
#include <new>
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <time.h>

// stuff brings vnds to a crawl, DEBUGGIN` only
#ifdef MEMCHECK

const int MAXALLOC = 1024; // because in one instance, 256b is done ~500 times

struct MemAlloc {
    void* pointer;
    int size;
    
};

static int mindex = 0;
static char buf[256];

static FILE* file;
static bool checkmem = false;
MemAlloc malloclist[MAXALLOC];


void* operator new(size_t len) 
{
    void* p = malloc(len);
    
    if (checkmem) {
        malloclist[mindex].pointer = p;
        malloclist[mindex].size = len;
        ++mindex;
        
        sprintf(buf, "  new: 0x%X: %db\n", p, len);
        fwrite(buf, sizeof(char), strlen(buf), file);
    }
    
    return p;
}

void* operator new[](size_t len) 
{
    void* p = malloc(len);
    
    if (checkmem) {
        malloclist[mindex].pointer = p;
        malloclist[mindex].size = len;
        ++mindex;
        
        sprintf(buf, "arnew: 0x%X: %db\n", p, len);
        fwrite(buf, sizeof(char), strlen(buf), file);
    }
    
    return p;
}

void operator delete(void* p)
{
    if (checkmem) {
        int i;
        for(i = 0; i < mindex; ++i) {
            if (malloclist[i].pointer == p) {
                break;
            }
        }
        if (i == mindex)
            return; // lolnothinghere
        
        sprintf(buf, "  del: 0x%X: %db\n", p, malloclist[i].size);
        fwrite(buf, sizeof(char), strlen(buf), file);
        
        --mindex;
        malloclist[i].pointer = malloclist[mindex].pointer;
        malloclist[i].size = malloclist[mindex].size;
    }
    
    free(p);
    p = NULL;
}

void operator delete[](void* p)
{
    if (checkmem) {
        int i;
        for(i = 0; i < mindex; ++i) {
            if (malloclist[i].pointer == p) {
                break;
            }
        }
        if (i == mindex)
            return; // lolnothinghere
        
        sprintf(buf, "ardel: 0x%X: %db\n", p, malloclist[i].size);
        fwrite(buf, sizeof(char), strlen(buf), file);
        
        --mindex;
        malloclist[i].pointer = malloclist[mindex].pointer;
        malloclist[i].size = malloclist[mindex].size;
    }
    
    free(p);
    p = NULL;
}


void StartMemCheck(const char* f, const int l)
{   
    time_t ti = time(NULL);
    tm* t = localtime(&ti);
    int year = t->tm_year + 1900;
    int month = t->tm_mon + 1;
    int day = t->tm_mday;
        
    sprintf(buf, "/vnds/memlog-%d-%d-%d.log", year, month, day);
    file = fopen(buf, "w");
    
    sprintf(buf, "staring log at %s:%d\n", f, l);
    fwrite(buf, sizeof(char), strlen(buf), file);
    
    checkmem = true;
}

void StopMemCheck(const char* f, const int l)
{
    checkmem = false;
    
    sprintf(buf, "staring log at %s:%d\n", f, l);
    fwrite(buf, sizeof(char), strlen(buf), file);
    fclose(file);
}


#endif /* MEMORYCHECKING */
